<template>
  <div class="full-container-p24">
    <div style="display: flex; justify-content: space-between">
      <div style="display: flex">
        <el-input
          placeholder="请输入姓名/手机号"
          prefix-icon="el-icon-search"
          v-model="term"
          clearable
          style="height: 32px; width: 330px; line-height: 32px"
          @keyup.enter="getSubAccountList"
        ></el-input>
        <div class="seach-btn" @click="getSubAccountList">查询</div>
      </div>
      <el-button v-auth="'ADDACCOUNT'" type="primary" @click="showAddModal">
        添加员工
      </el-button>
    </div>

    <el-dialog
      v-model="visable"
      :title="accountId ? '修改员工' : '添加员工'"
      width="550px"
      @close="resetForm()"
    >
      <template v-slot:default>
        <div class="df jcc">
          <el-form
            :model="ruleForm"
            :rules="rules"
            ref="form"
            label-width="110px"
            label-position="left"
          >
            <el-form-item prop="name" label="姓名">
              <el-input style="width: 280px" v-model="ruleForm.name"></el-input>
            </el-form-item>
            <el-form-item prop="phone" label="手机号">
              <el-input
                style="width: 280px"
                v-model="ruleForm.phone"
              ></el-input>
            </el-form-item>
            <el-form-item prop="deptId" label="部门">
              <el-select
                style="width: 280px"
                v-model="ruleForm.deptId"
                placeholder="请选择部门"
                @change="getRoleSelect"
              >
                <el-option
                  v-for="item in departmentSelect"
                  :key="item"
                  :label="item.value"
                  :value="item.key"
                />
              </el-select>
            </el-form-item>
            <el-form-item v-if="ruleForm.deptId" prop="roleId" label="职位">
              <el-select
                style="width: 280px"
                v-model="ruleForm.roleId"
                placeholder="请选择职位"
              >
                <el-option
                  v-for="item in roleSelect"
                  :key="item"
                  :label="item.value"
                  :value="item.key"
                />
              </el-select>
            </el-form-item>
          </el-form>
        </div>
      </template>
      <template v-slot:footer>
        <div class="dialog-footer">
          <el-button @click="resetForm">取 消</el-button>
          <el-button type="primary" @click="addSubAccount(ruleForm)">
            确 定
          </el-button>
        </div>
      </template>
    </el-dialog>

    <div style="margin-top: 24px">
      <el-table :data="tableData" stripe style="width: 100%">
        <el-table-column
          type="index"
          label="序号"
          min-width="40"
          align="center"
        ></el-table-column>
        <el-table-column
          prop="userName"
          label="姓名"
          min-width="80"
          align="center"
        ></el-table-column>
        <el-table-column
          prop="phone"
          label="手机号"
          min-width="100"
          align="center"
        ></el-table-column>
        <el-table-column
          prop="password"
          label="密码"
          min-width="80"
          align="center"
        ></el-table-column>
        <el-table-column
          prop="deptName"
          label="部门"
          min-width="80"
          align="center"
        ></el-table-column>
        <el-table-column
          prop="roleName"
          label="职位"
          min-width="80"
          align="center"
        ></el-table-column>
        <el-table-column
          v-auth="'ADDACCOUNT'"
          label="操作"
          min-width="120"
          align="center"
        >
          <template v-slot="scope">
            <div class="df aic jcsa">
              <!-- <el-switch
                v-model="scope.row.accountStatus"
                active-color="#13ce66"
                inactive-color="#ff4949"
                active-text="启用"
                inactive-text="禁用"
                :active-value="1"
                :inactive-value="0"
              />

              <div
                style="
                  color: red;
                  margin-left: 10px;
                  font-size: 14px;
                  text-decoration: underline;
                  cursor: pointer;
                "
              >
                删除
              </div> -->
              <el-button
                @click="showUpdateModal(scope.row, 1)"
                size="small"
                type="primary"
              >
                修改员工权限
              </el-button>
            </div>
          </template>
        </el-table-column>
      </el-table>
      <div style="width: 100%; text-align: right; margin-top: 43px">
        <el-pagination
          background
          layout="prev, pager, next"
          :total="total"
          @current-change="pageChange"
        ></el-pagination>
      </div>
    </div>
  </div>
</template>

<script setup>
import api from "../../apis/fetch";
import { ref, onMounted, reactive } from "vue";
import { ElNotification, ElMessageBox } from "element-plus";
import store from "../../store/index";

let tableData = ref([]);
let currentPage = ref(1);
let total = ref(0);
let term = ref("");
let loginAccountId = ref(0);
let accountId = ref("");
let ruleForm = ref({
  name: "",
  phone: "",
  roleId: "",
  deptId: "",
});
const rules = reactive({
  name: [
    {
      required: true,
      message: "请填写名称",
      trigger: "blur",
    },
  ],
  phone: [
    {
      required: true,
      message: "请填写手机号",
      trigger: "blur",
    },
  ],
  roleId: [
    {
      required: true,
      message: "请选择职位",
      trigger: "blur",
    },
  ],
  deptId: [
    {
      required: true,
      message: "请选择部门",
      trigger: "blur",
    },
  ],
});

function showAddModal() {
  visable.value = true;
  ruleForm.value = {
    name: "",
    phone: "",
    roleId: "",
    deptId: "",
  };
}

async function getSubAccountList() {
  let res = await api.getSubAccountList({
    term: term.value,
    currentPage: currentPage.value,
    size: 10,
    loginAccountId: loginAccountId.value,
  });
  if (res.data.status == 0) {
    tableData.value = res.data.result;
    for (let i of tableData.value) {
      if (i.roleId == 0) {
        i.roleId = "";
      }
    }
    total.value = res.data.total;
  } else {
    tableData.value = [];
    total.value = 0;
  }
}

function pageChange(e) {
  currentPage.value = e;
  getSubAccountList();
}
let visable = ref(false);
let form = ref(null);
async function addSubAccount() {
  let postData = {
    ...ruleForm.value,
    loginAccountId: loginAccountId.value,
  };
  if (accountId.value) {
    postData.accountId = accountId.value;
  }
  let res = await api[accountId.value ? "updateSubAccount" : "addSubAccount"](
    postData
  );
  if (res.data.status == 0) {
    ElNotification({
      title: "成功",
      duration: 1500,
      message: res.data.msg,
      type: "success",
    });
    store.dispatch("GetBasePermissionData", localStorage.loginAccountId);
    store.dispatch("GetUserPermission", localStorage.loginAccountId);
    resetForm();
    getSubAccountList();
  } else {
    ElNotification({
      title: "失败",
      duration: 1500,
      message: res.data.msg,
      type: "error",
    });
  }
}
function resetForm() {
  visable.value = false;
  accountId.value = "";
  form.value.resetFields();
}

function showUpdateModal(item, type) {
  visable.value = true;
  accountId.value = item.id;
  ruleForm.value = {
    name: item.userName,
    phone: item.phone,
    deptId: item.deptId,
    roleId: item.roleId,
  };
  getRoleSelect(type);
}

let roleSelect = ref([]);

async function getRoleSelect(type) {
  roleSelect.value = [];
  if (!ruleForm.value.deptId) return;
  if (type != 1) ruleForm.value.roleId = "";
  let res = await api.getRoleSelect({
    loginAccountId: loginAccountId.value,
    deptId: ruleForm.value.deptId,
  });
  roleSelect.value = res.data.result;
}
let departmentSelect = ref([]);
async function getDepartmentSelect() {
  let res = await api.getDepartmentSelect({
    loginAccountId: loginAccountId.value,
  });
  departmentSelect.value = res.data.result;
}

onMounted(() => {
  loginAccountId.value = localStorage.loginAccountId;
  getSubAccountList();
  getDepartmentSelect();
});
</script>

<style scoped>
.seach-btn {
  display: inline-block;
  width: 60px;
  height: 38px;
  background: #0094fe;
  border-radius: 2px;
  font-size: 14px;
  font-family: PingFangSC-Regular, PingFang SC;
  font-weight: 400;
  color: #ffffff;
  text-align: center;
  line-height: 38px;
  margin-left: 10px;
  cursor: pointer;
}
</style>
